
proc
//Gradiates a text string with two colors.
//Arguements:
//    text:          the text string to be gradiated.
//    list/color_1:  The first color of the desired gradient.
//    list/color_2:  The second color of the desired gradient.
	gradiate(string,list/color_1,list/color_2)
		if(color_1.len!=3 || color_2.len!=3 || !length(string)) return null
		var
			r1=rgbLimit(color_1[1]);g1=rgbLimit(color_1[2]);b1=rgbLimit(color_1[3])
			r2=rgbLimit(color_2[1]);g2=rgbLimit(color_2[2]);b2=rgbLimit(color_2[3])
			text
			textLength=length(string)
			red=(r2-r1)/textLength
			green=(g2-g1)/textLength
			blue=(b2-b1)/textLength
		for(var/i=1,i<=textLength+1,i++) text+="<span style=\"color: [rgb(round(i*red+r1),round(i*green+g1),round(i*blue+b1))];\">[copytext(string,i,i+1)]</span>"
		return text

//Gradiates a text string x amount of colors. If the text length is less than the
//amount of colors, than it will return a gradiation of the first and last color.
//The colors are capped at 10 maximum.
//Arguements:
//    text:          the text string to be gradiated.
//    list/colors:   a list that should contain more lists inside of it. the lists inside
//                   should have the same format as rgb(r,g,b), only as list(r,g,b) instead.
	multi_gradiate(string,list/colors)
		if(colors.len>length(string) || !length(string)) return null
		var/segmentLen=round(length(string)/(colors.len-1))
		var/segments=colors.len-1
		var/colorPos_1=1
		var/colorPos_2=2
		var/posStart=1
		var/text
		var/i=0
		while(i<segments)
			i++
			if(i==segments && length(string)>0) text+=gradiate(copytext(string,posStart),colors[colorPos_1],colors[colorPos_2])
			else text+=gradiate(copytext(string,posStart,segmentLen+1),colors[colorPos_1],colors[colorPos_2])
			string=copytext(string,segmentLen+1)
			colorPos_1++;colorPos_2++
		return text

//Makes sure that n does not exceed the limits of RGB.
//Arguements:
//    n as num:      n is the number that you want filtered for gradiating.
	rgbLimit(n as num)
		if(n>=255) return 255
		else if(n<=0) return 0
		else return n

/*Testing Verbs.
mob/verb
	gradiate_test(t as text)
		var/text=gradiate(t,list(255,255,0),list(255,0,255))
		if(text) world<<text
	multi_gradiate_test(t as text)
		var/text=multi_gradiate(t,list(list(255,0,0),list(255,255,0),list(255,0,255),list(0,255,0),list(0,0,255)))
		if(text) world<<text
*/